#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include "testlib.h"
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;

int main(int argc, char* argv[]) {
  registerGen(argc, argv, 1);

  int n = opt<int>("n");
  int m = opt<int>("m");
  int dir = opt<int>("dir");
  int back = opt<int>("back");
  int shuf = opt<int>("shuf");

  vector<pair<int, int>> e(m);
  set<pair<int, int>> s;
  for (int i = 0; i < m; i++) {
    if (i < n - 1) {
      e[i] = {i, i + 1};
    } else {
      int x, y;
      do {
        x = rnd.next(n);
        y = rnd.next(n);
      } while (x == y || (back && x < y) || s.find(make_pair(x, y)) != s.end());
      e[i] = {x, y};
    }
    s.insert(e[i]);
  }
  if (dir) {
    for (auto& [x, y] : e) {
      swap(x, y);
    }
  }
  if (shuf) {
    shuffle(e.begin(), e.end());
  }

  cout << 1 << '\n';
  cout << n << " " << m << '\n';
  for (auto& [x, y] : e) {
    cout << x + 1 << " " << y + 1 << '\n';
  }

  return 0;
}